Problem
Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
Solution
Approach 1 : Brute Force
The brute force approach is simple.
Loop through each element x and find if there is another value that equals to target - x.
def twoSum(nums, target): for i in range(len(nums)) : for j in range(i+1, len(nums)) : if nums[i] + nums[j] == target : return [i, j] | cs |
Complexity Analysis
⏳Time complexity : For each element, we try to find its complement by looping through the rest of array which takes O(n) time.
.
🏠Space complexity : .
Approach 2 : Two-pass Hash Table
To improve our run time complexity, we need a more efficient way to check if the complement exists in the array. If the complement exists, we need to look up its index. What is the best way to maintain a mapping of each element in the array to its index? A hash table.
We reduce the look up time from O(n) to O(1) by trading space for speed. A hash table is built exactly for this purpose, it supports fast look up in near constant time. I say "near" because if a collision occured, a look up could degenerate to O(n) time. But look up in hash table should be amortized O(1) time as long as the hash function was chosen carefully.
A simple implementation uses two iterations.
1. In the first iteration, we add each element's value and its index to the table.
2. In the second iteration we check if each element's complement(target - nums[i]) exists in the table. (Beware that the complement must not be nums[i] itself!)
def twoSum(nums, target): hashmap = {} for i in range(len(nums)) : hashmap[nums[i]] = i for i in range(len(nums)) : complement = target - nums[i] if complement in hashmap and hashmap[complement] != i: return [i, hashmap[complement]] |
Approach 3 : One-pass Hash Table
def twoSum(nums, target): hashmap = {} for i in range(len(nums)) : complement = target - nums[i] if complement in hashmap : return [i, hashmap[complement]] hashmap[nums[i]] = i | cs |
More pythonic way below
def twoSum(nums, target): hashmap = dict() for i, val in enumerate(nums) : if val in hashmap : return [hashmap.get(val), i] hashmap[target-val] = i | cs |
'0 > algorithm' 카테고리의 다른 글
Longest Substring Without Repeating Characters (in Python) (0) | 2019.01.18 |
---|---|
Add two numbers (in Python) (0) | 2019.01.18 |
우선순위 큐 (priority queue), 힙 정렬 (heap sort) (0) | 2018.12.21 |
정렬 알고리즘 (sorting algorithm) 정리 (0) | 2018.12.21 |
백준 1918번 후위표기식 (Python) (0) | 2018.11.15 |